<script setup lang="ts">
import { computed, type PropType, ref } from "vue";
import ParameterGroupDescription from "@/components/parameter-schema/description-mode/ParameterGroupDescription.vue";
import type { ClowmInfo } from "@/types/ClowmInfo";
import GroupNav from "@/components/parameter-schema/GroupNav.vue";
import {
  ParameterVisibility,
  type ParameterVisibilityMapping,
} from "@/client/types.gen.ts";

const props = defineProps({
  schema: {
    type: Object,
    required: true,
  },
  clowmInfo: {
    type: Object as PropType<ClowmInfo>,
    required: false,
  },
  parameterVisibility: {
    type: Object as PropType<ParameterVisibilityMapping>,
    required: false,
  },
});

const viewMode = ref<ParameterVisibility>(ParameterVisibility.SIMPLE);

/* eslint-disable @typescript-eslint/ban-ts-comment */
// @ts-ignore
const defaultParameterVisibility = computed<ParameterVisibilityMapping>(() => {
  const mapping: ParameterVisibilityMapping = {};
  const groups: object = schemaDefinitions.value;
  for (const groupName of Object.keys(groups)) {
    /* eslint-disable @typescript-eslint/ban-ts-comment */
    // @ts-ignore
    const group = groups[groupName];
    const anyOfDeps: string[] = (group["anyOf"] ?? [])
      .map((dep: Record<string, string[]>) => dep["required"])
      .flat();
    const oneOfDeps: string[] = (group["oneOf"] ?? [])
      .map((dep: Record<string, string[]>) => dep["required"])
      .flat();
    const requiredDeps: string[] = group["required"] ?? [];
    const temp: Record<string, string[]> =
      group["dependentRequired"] ?? group["dependencies"] ?? {};
    const parameterDeps: string[] = Object.keys(temp)
      .map((param) => temp[param])
      .flat();

    for (const paramName of Object.keys(group["properties"] ?? {})) {
      const param: { hidden?: boolean } = group["properties"][paramName];
      if (
        anyOfDeps.includes(paramName) ||
        oneOfDeps.includes(paramName) ||
        requiredDeps.includes(paramName) ||
        parameterDeps.includes(paramName)
      ) {
        mapping[paramName] = ParameterVisibility.SIMPLE;
      } else if (!(param.hidden ?? false)) {
        mapping[paramName] = ParameterVisibility.ADVANCED;
      } else {
        mapping[paramName] = ParameterVisibility.EXPERT;
      }
    }
  }
  for (const paramName of Object.keys(props.schema["properties"] ?? {})) {
    mapping[paramName] =
      (props.schema["properties"][paramName]["hidden"] ?? false)
        ? ParameterVisibility.EXPERT
        : ParameterVisibility.ADVANCED;
  }
  return mapping;
});

const currentParameterVisibility = computed<ParameterVisibilityMapping>(
  () => props.parameterVisibility ?? defaultParameterVisibility.value,
);

const schemaDefinitions = computed<Record<string, object>>(
  () => props.schema?.["definitions"] ?? props.schema?.["$defs"],
);

/* eslint-disable @typescript-eslint/ban-ts-comment */
// @ts-ignore
const parameterGroups = computed<Record<string, never>>(() => {
  if (Object.keys(props.schema?.["properties"] ?? {}).length > 0) {
    return {
      ...schemaDefinitions.value,
      ungrouped_parameters: {
        title: "Ungrouped Parameters",
        properties: props.schema?.["properties"],
        type: "object",
      },
    };
  }
  return schemaDefinitions.value;
});
</script>

<template>
  <div class="row px-2 mb-5 align-items-start">
    <div class="col-9">
      <div v-for="(group, groupName) in parameterGroups" :key="groupName">
        <parameter-group-description
          :schema-properties="parameterGroups"
          class="schema-group-description"
          :parameter-group-name="groupName"
          :parameter-visibility="currentParameterVisibility"
          :current-visibility="viewMode"
          :resource-parameters="props.clowmInfo?.resourceParameters"
        />
      </div>
    </div>
    <group-nav
      :parameter-groups="parameterGroups"
      :parameter-visibility="currentParameterVisibility"
      :clowm-info="props.clowmInfo"
      @change-view-mode="(newViewMode) => (viewMode = newViewMode)"
    />
  </div>
</template>

<style scoped>
.schema-group-description:last-of-type {
  border-bottom: var(--bs-border-width) var(--bs-border-style) !important;
}
</style>
